/*
//Code for Arduino ATMEGA/ESP32 master receiver

Author : Vincent Chanengeta

*/

#include <Wire.h>

float temperature;
byte sensorAdd = 8; //slave sensor address

void setup() 
{
  Wire.begin();
  Serial.begin(115200);
}

void loop() 
{
  temperature = RequestingTemperature(sensorAdd); //the function gets temperature from your I2C slave device.
  Serial.println(temperature);
  delay(2000);
}

//----------------------------------------------------------------------------------------
//My functions

float RequestingTemperature(byte sAdd)
{
  Wire.requestFrom(sAdd, 2);
  //The wire can only transfer 1 byte at a time.
  //We need to receive temperature values in 2 bytes since temperature is a float, but the values are received as integers.
  //If the temperature is 25.42 °C, we receive a byte with 25, and another byte with 42.
  //Once we have received all the data we add 25 and 42/100 to get back our float number.

  int data[2];
  float temperature;

  if (Wire.available()) 
  {
    data[0] = Wire.read();
    data[1] = Wire.read();
  }

  temperature = data[0] + (float)data[1]/100;

  return temperature;

}
